define(["exports", "core/pubsubhub"], function (exports, _pubsubhub) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.name = undefined;
  var name = exports.name = "core/respec-ready"; /**
                                                  * This Module adds a `respecIsReady` property to the document object.
                                                  * The property returns a promise that settles when ReSpec finishes
                                                  * processing the document.
                                                  */


  var respecDonePromise = new Promise(function (resolve) {
    (0, _pubsubhub.sub)("end-all", resolve, { once: true });
  });

  Object.defineProperty(document, "respecIsReady", {
    get: function get() {
      return respecDonePromise;
    }
  });
});
//# sourceMappingURL=respec-ready.js.map